/*****************************************************
This program was produced by the
CodeWizardAVR V2.04.4a Advanced
Automatic Program Generator
 Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 03.10.2010
Author  : NeVaDa
Company : Microsoft
Comments: 


Chip type               : ATmega8535L
Program type            : Application
AVR Core Clock frequency: 16,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 128
*****************************************************/

#include <mega8535.h>

#include <delay.h>
/*
// 1 Wire Bus functions
#asm
   .equ __w1_port=0x18 ;PORTB
   .equ __w1_bit=4
#endasm
#include <1wire.h>
#include <ds1820.h>
#define MAX_DS1820 8
volatile unsigned char ds1820_devices;
volatile unsigned char ds1820_rom_codes[MAX_DS1820][9];
*/
//eeprom volatile unsigned char rejim_eep;//       0  ,
//eeprom volatile unsigned char zadanie_I_eep; //      
//eeprom volatile unsigned char zadanie_U_eep; //      
volatile unsigned char start1;//   5   
volatile unsigned char soft_start;//  
volatile unsigned char rejim;//       0  ,
                                    //1   
                                    //2  
                                    //3   
volatile unsigned char zadanie_I; //    
volatile unsigned char I_ADC;      //   I
volatile unsigned char izmerenoe_I;//        
volatile unsigned char zadanie_U; //    
volatile unsigned char U_ADC;      //   U
volatile unsigned char izmerenoe_U;//        
volatile unsigned char start;      //    0   , 1  
volatile unsigned char indy_I;//         
volatile unsigned char indy_U;//         
/********************************* ***************************************************************/
void start_310 (void){//       
delay_ms (20);      // 2       
PORTB.0=1;            //   
if (zadanie_I==0){    //    0     
zadanie_I=1;          //    
//zadanie_I_eep=zadanie_I;
}
if (zadanie_U==0){    //    0
zadanie_U=1;          //    
//zadanie_U_eep=zadanie_U;
}
delay_ms (5);       // 0,5 
TCCR2=0x6E;         //  2             
}
/*******************************************************************************************************************/
/*************************************   250 *****************************************************/
interrupt [TIM2_OVF] void timer2_ovf_isr(void)
{
start1++;
if (start1==5){// start1  ==5 
soft_start++;  //  soft_start  1 
start1=0;      // start1
}
if (rejim==0 || rejim==1 & soft_start<zadanie_I){//         
OCR2=soft_start;                                 //  
}
if (rejim==2 || rejim==3 && soft_start<zadanie_U){//         
OCR2=soft_start;                                 //  
}
if (OCR2==zadanie_I || OCR2==zadanie_U){//      
TIMSK=0x01;//      2      0 "00000001"
TCCR0=0x03;//   0         250 
start=1;//   
}
}
/*******************************************************************************************************************/
/****************************  0 250 ***********************************************************/
volatile unsigned int divider_500;//  500 500   
volatile unsigned char divider_indy;//     
volatile long int divider_125000;//  125000 0,5
volatile unsigned int divider_2500;//  2500 100   
volatile unsigned char divider_button;//  
volatile unsigned int divider_250;//  250 1000   
volatile unsigned char divider_pulse;//   500
interrupt [TIM0_OVF] void timer0_ovf_isr(void){
divider_500++;
if (divider_500==500){
divider_500=0;
divider_indy=1;
}
divider_125000++;
if (divider_125000==125000){
divider_125000=0;
}
divider_2500++;
if (divider_2500==25){
divider_2500=0;
divider_button=1;
}
divider_250++;
if (divider_250==125){
divider_pulse=1;
}
if (divider_250==250){
divider_pulse=0;
}
}
/*******************************************************************************************************************/
/*************************************   *******************************************
interrupt [ANA_COMP] void ana_comp_isr(void){//    
TCCR2=0x00;                                  //  2  
start=0;                                     // 
}
*******************************************************************************************************************/
/****************************************************************************************************************/
//  ADC6  
volatile unsigned char calculator_bufer_I[4]={0,0,0,0};//    
volatile unsigned char calculator_bufer_U[4]={0,0,0,0};//    
void ADC_I (void){ //  ADC6
ADMUX=0b00100110;
ADCSRA=0b11000001;// 2
delay_us(8);
I_ADC=ADCH;
calculator_bufer_I[3]=calculator_bufer_I[2];
calculator_bufer_I[2]=calculator_bufer_I[1];
calculator_bufer_I[1]=calculator_bufer_I[0];
calculator_bufer_I[0]=I_ADC;
izmerenoe_I=(calculator_bufer_I[3]+calculator_bufer_I[2]+calculator_bufer_I[1]+calculator_bufer_I[0])/4;
indy_I=izmerenoe_I;
}
//  ADC7  
void ADC_U (void){ //  ADC7
ADMUX=0b00100111;
ADCSRA=0b11000001;// 2
delay_us(8);
U_ADC=ADCH;
calculator_bufer_U[3]=calculator_bufer_U[2];
calculator_bufer_U[2]=calculator_bufer_U[1];
calculator_bufer_U[1]=calculator_bufer_U[0];
calculator_bufer_U[0]=U_ADC;
izmerenoe_U=(calculator_bufer_U[3]+calculator_bufer_U[2]+calculator_bufer_U[1]+calculator_bufer_U[0])/4;
indy_U=izmerenoe_U;
}
/*******************************************************************************************************************/
/******************************************** ***********************************************************/
// 
void PWM_control_I (void){
if ((izmerenoe_I < zadanie_I) & soft_start<255){//     soft_start<255
soft_start++;                                 // 
OCR2=soft_start;                              //        
}
if ((izmerenoe_I > zadanie_I) & soft_start>0){//     soft_start>0
soft_start--;                               // 
OCR2=soft_start;                            //        
}
}
/*// 
void PWM_control_U (void){
volatile unsigned char control_U;//      
control_U=izmerenoe_U;
if (izmerenoe_U < zadanie_U){
control_U++;
OCR2=control_U;
}
if (izmerenoe_U > zadanie_U){
control_U--;
OCR2=control_U;
}
}
*/
/*******************************************************************************************************************/
/******************************************* **************************************************/
/*********************   *******
              a
            -----
          f|     |b
           |  g  |
            -----
          e|     |c
           |  d  |
            ----- *h
g      f      e      d      c      b      a      in
p7    p6    p5    p4    p3    p2    p1    p0
**********************************************************************/
#define dig1I PORTA.2//PORTD.5         dig1I
#define dig2I PORTA.1//PORTD.6         dig2I
#define dig3I PORTA.0//PORTD.7        dig3I
#define dig1U PORTA.5//PORTD.5         dig1U
#define dig2U PORTA.4//PORTD.6         dig2U
#define dig3U PORTA.3//PORTD.7        dig3U
unsigned char sym[]={
0b10000001, //(0)0
0b11110011, //(1)1
0b01001001, //(2)2
0b01100001, //(3)3
0b00110011, //(4)4
0b00100101, //(5)5
0b00000101, //(6)6
0b11110001, //(7)7
0b00000001, //(8)8
0b00100001, //(9)9
0b00001101, //(10)E
0b01011111, //(11)r
0b11111111  //(12)  
};

volatile unsigned char cur_dig;//  
volatile unsigned char sym_out[6];// sym_out   ( 6)        
volatile unsigned char indy_static_I;//         
volatile unsigned char indy_static_U;//         
/*****************************************************************/
void recoding (void){             
/****************** *****************************/
if (divider_indy==1){
indy_static_I=indy_I;
indy_static_U=indy_U;
if (indy_static_I<255){              //  indication  255
indy_I=izmerenoe_I;                  //indy_I  izmerenoe_I  divider_1000  1
sym_out[0]=indy_I%10;                //  sym_out 0        
indy_I=indy_I/10;                    //  indication      380  38
sym_out[1]=indy_I%10;                //  8   
indy_I=indy_I/10;                    // 38  3
sym_out[2]=indy_I;                   //    3
}
else                              // 
{
sym_out[0]=11;                   //
sym_out[1]=10;                   //Er
sym_out[2]=12;                   // 0   
}
/****************** **********************/
if (indy_static_U<255){  //  indication  255
indy_U=izmerenoe_U;      //indy_U  izmerenoe_U
sym_out[3]=indy_U%10;    //  sym_out 0        
indy_U=indy_U/10;        //  indication      380  38
sym_out[4]=indy_U%10;    //  8   
indy_U=indy_U/10;        // 38  3
sym_out[5]=indy_U;       //    3
}
else                     // 
{
sym_out[3]=11;           //
sym_out[4]=10;           //Er
sym_out[5]=12;           // 0   
}

/**********     ********************/
PORTC=sym[12];                                                         //  C
switch (cur_dig){                                                      //   
case 0:{dig1I=1; dig2I=0; dig3I=0; dig1U=0; dig2U=0; dig3U=0; break;}; //    1 
case 1:{dig2I=1; dig3I=0; dig1I=0; dig1U=0; dig2U=0; dig3U=0; break;}; //    2 
case 2:{dig3I=1; dig1I=0; dig2I=0; dig1U=0; dig2U=0; dig3U=0; break;}; //    3 
case 3:{dig1U=1; dig3I=0; dig1I=0; dig2I=0; dig2U=0; dig3U=0; break;}; //    1 
case 4:{dig2U=1; dig1U=0; dig3I=0; dig1I=0; dig2I=0; dig3U=0; break;}; //    2 
case 5:{dig3U=1; dig2U=0; dig1U=0; dig3I=0; dig1I=0; dig2I=0; break;}; //    3 
}

if (indy_static_I<10){                 //  adc_dataI<10
dig2I=0; dig1I=0;                          // 2  
}
if (indy_static_I<100){                //  adc_dataI<100
dig2I=0;                                   // 1  
}
if (indy_static_U<10){                //  adc_dataI<10
dig2U=0; dig1U=0;                         // 2  
}
if (indy_static_U<100){               //  adc_dataI<100
dig2U=0;                                  // 1  
}
if (divider_indy==1){
PORTC=sym[sym_out[cur_dig]];              //   C   
cur_dig=cur_dig+1;                        //  cur_dig  1
if (cur_dig==6){
 cur_dig=0;                               //  cur_dig     5
}
}
}
divider_indy=0;                          //    
}
/*******************************************************************************************************************/
/*************************************************************************************************************/
void button (void){
#define b_bolshe PIND.0                                       // 
#define b_menshe PIND.1                                       // 
#define b_rejim PIND.2                                        //  
#define b_parametr PIND.3                                     //  
float koficient;                                               //      
if (divider_button==1){                                        //  100    
if (b_rejim==0 && b_bolshe==1 && b_menshe==1 && b_parametr==1){//    
rejim++;                                                       //   
if (rejim==4){                                                 // 
rejim=0;                                                       //   3 
}
}
if (b_bolshe==0 && b_menshe==1 && b_rejim==1 && b_parametr==1 && rejim==0 || rejim==1){//         
zadanie_I++;
koficient=zadanie_I/1.275;
indy_I=(unsigned char)koficient;
}
if (b_menshe==0 && b_bolshe==0 && b_parametr==1 && b_rejim==1 && rejim==0 || rejim==1){//         
zadanie_I--;
koficient=zadanie_I/1.275;
indy_I=(unsigned char)koficient;
}
if (b_bolshe==0 && b_menshe==1 && b_rejim==1 && b_parametr==1 && rejim==2 || rejim==3){//         
zadanie_U++;
koficient=zadanie_U/1.275;
indy_U=(unsigned char)koficient;
}
if (b_menshe==0 && b_bolshe==0 && b_parametr==1 && b_rejim==1 && rejim==2 || rejim==3){//         
zadanie_U--;
koficient=zadanie_U/1.275;
indy_U=(unsigned char)koficient;
}
}
divider_button=0;//   
}
/*******************************************************************************************************************/
/**********************************************************************************************************/
#define l_pad PORTD.4
#define l_pad_pulse PORTD.5
#define l_jest PORTD.6
#define l_jest_pulse PORTB.5
#define l_alarm PORTB.7
void led_rejim (void){
switch (rejim){
case 0:{l_pad=0; l_pad_pulse=1; l_jest=1; l_jest_pulse=1; break;};
case 1:{l_pad_pulse=0; l_pad=1; l_jest=1; l_jest_pulse=1; break;};
case 2:{l_jest=0; l_pad_pulse=1; l_pad=1; l_jest_pulse=1; break;};
case 3:{l_jest_pulse=0; l_jest=1; l_pad_pulse=1; l_pad=1; break;};
}
}
/*******************************************************************************************************************/
/**************************************** **********************************************************/

/*******************************************************************************************************************/

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=T State6=T State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTA=0x00;
DDRA=0x3F;

// Port B initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=1 State6=1 State5=1 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTB=0xE0;
DDRB=0xFF;

// Port C initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1 
PORTC=0xFF;
DDRC=0xFF;

// Port D initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In 
// State7=0 State6=1 State5=1 State4=1 State3=P State2=P State1=P State0=P 
PORTD=0x7F;
DDRD=0xF0;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0 output: Disconnected
TCCR0=0x00;
TCNT0=0x00;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
MCUCR=0x00;
MCUCSR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x40;

// Analog Comparator initialization
// Analog Comparator: On
// The Analog Comparator's positive input is
// connected to the Bandgap Voltage Reference
// Interrupt on Falling Output Edge
// Analog Comparator Input Capture by Timer/Counter 1: Off
//ACSR=0x4A;
ACSR=0x00;
SFIOR=0x00;

/*** ADC initialization
// ADC Clock frequency: 1000,000 kHz
// ADC Voltage Reference: AREF pin
// ADC High Speed Mode: Off
// ADC Auto Trigger Source: Free Running
// Only the 8 most significant bits of
// the AD conversion result are used
ADMUX=ADC_VREF_TYPE & 0xff;
ADCSRA=0xA4;
SFIOR&=0x0F;
***/
// Determine the number of DS1820 devices
// connected to the 1 Wire bus
//ds1820_devices=w1_search(0xf0,ds1820_rom_codes);

// Global enable interrupts
#asm("sei")
/*******************************************************************************************************************/
start_310();
while (1){
/************************ ******************************************************************************/
while (start==1 & rejim==0){//        
ADC_I();                     //  
PWM_control_I();             //    
ADC_U();                     // 
recoding ();                 //    
button();                    // 
led_rejim();                 //      
}
/************************  ******************************************************************/
while (start==1 & rejim==1){//         
if (divider_pulse==1){       //  
if (TCCR2==0x00){            //  
TCCR2=0x6E;                  //  
}
ADC_I();                     //  
PWM_control_I();             //    
ADC_U();                     // 
recoding ();                 //    
button();                    // 
led_rejim();                 //     
}
if (divider_pulse==0){       // 
if (TCCR2==0x6E){            //  
TCCR2=0x00;                  //  
}
recoding ();                 //    
button();                    // 
led_rejim();                 //     
}
}
/*********************** ***********************************************************************/
while (start==1 & rejim==2){//        
button();                    // 
led_rejim();                 //     
}
/************************  ************************************************************/
while (start==1 & rejim==3){//         
button();                    // 
led_rejim();                 //     
}
}







}
